Bug 230936 - x11/kde-workspace-kde4, deskutils/superkaramba-kde4: fail to build with clang 7 (blocks 27 + 1 ports)
Summary: x11/kde-workspace-kde4, deskutils/superkaramba-kde4: fail to build with clang...
Status: Closed FIXED
Alias: None
Product: Ports & Packages
Classification: Unclassified
Component: Individual Port(s) (show other bugs)
Version: Latest
Hardware: Any Any
: --- Affects Only Me
Assignee: kde
URL:
Keywords: needs-patch
Depends on:
Blocks: 230355
  Show dependency treegraph
 
Reported: 2018-08-27 13:53 UTC by Jan Beich
Modified: 2018-10-02 14:16 UTC (History)
1 user (show)

See Also:
bugzilla: maintainer-feedback? (kde)


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Jan Beich freebsd_committer 2018-08-27 13:53:57 UTC
$ poudriere jail -cj clang7 -a amd64 -v projects/clang700-import -m svn+https
$ poudriere testport -j clang7 x11/kde-workspace-kde4
[...]
libs/taskmanager/task.cpp:481:27: error: ordered comparison between pointer and zero ('const void *' and 'int')
    if (id1.contains(id2) > 0)
        ~~~~~~~~~~~~~~~~~ ^ ~
libs/taskmanager/task.cpp:484:27: error: ordered comparison between pointer and zero ('const void *' and 'int')
    if (id2.contains(id1) > 0)
        ~~~~~~~~~~~~~~~~~ ^ ~

http://package18.nyi.freebsd.org/data/headamd64PR230355gnucxx98-default/2018-08-26_10h16m34s/logs/errors/kde-workspace-kde4-4.11.22_25.log
Comment 1 Jan Beich freebsd_committer 2018-08-27 14:00:44 UTC
Same issue in another package with slightly older version of taskmanager.

$ poudriere jail -cj clang7 -a amd64 -v projects/clang700-import -m svn+https
$ poudriere testport -j clang7 deskutils/superkaramba-kde4
[...]
src/taskmanager.cpp:911:27: error: ordered comparison between pointer and zero ('const void *' and 'int')
    if (id1.contains(id2) > 0)
        ~~~~~~~~~~~~~~~~~ ^ ~
src/taskmanager.cpp:914:27: error: ordered comparison between pointer and zero ('const void *' and 'int')
    if (id2.contains(id1) > 0)
        ~~~~~~~~~~~~~~~~~ ^ ~

http://package18.nyi.freebsd.org/data/headamd64PR230355gnucxx98-default/2018-08-26_10h16m34s/logs/errors/superkaramba-kde4-4.14.3_5.log
Comment 2 Jan Beich freebsd_committer 2018-08-27 14:13:12 UTC
Note, if you have trouble reaching the affected ports due to dependencies try creating a jail with C++98 by default. Clang (unlike GCC) rejects malformed ordered comparisons with any C++ standard.

$ fetch -qo /tmp/clang7.c++98.diff 'https://bugs.freebsd.org/bugzilla/attachment.cgi?id=196011'
$ poudriere jail -cj clang7 -P /tmp/clang7.c++98.diff -v projects/clang700-import -m svn+https
Comment 3 commit-hook freebsd_committer 2018-08-30 10:09:45 UTC
A commit references this bug:

Author: adridg
Date: Thu Aug 30 10:09:41 UTC 2018
New revision: 478440
URL: https://svnweb.freebsd.org/changeset/ports/478440

Log:
  Fix build with clang7.

  PR:		230936
  Reported by:	jbeich

Changes:
  head/x11/kde-workspace-kde4/files/patch-khotkeys_libkhotkeysprivate_windows__helper_window__selection__rules.cpp
  head/x11/kde-workspace-kde4/files/patch-libs_taskmanager_task.cpp
  head/x11/kde-workspace-kde4/files/patch-plasma_generic_dataengines_weather_ions_bbcukmet_ion__bbcukmet.cpp
Comment 4 Adriaan de Groot freebsd_committer 2018-10-02 14:16:08 UTC
There were fixes committed in august and september.